package com.javaseleniumtemplate.pages.EstoquePages;
import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;


public class RetiradaDeEstoquePage  extends PageBase{

    //Evento de loading da pagina:
    By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");
    //BUSCA DO PRODUTO ATRAVES DO FLOAT-CONTROL:
    By iconFloatLupa = By.xpath("//*[@data-zh-id='zh-floating-control-handle']");
    By iconReflesh = By.xpath("//*[@data-zh-id='2085279469498787152459']//*[@data-zh-icon='refresh no-border icon-white']");
    By campoProcurarFloatControl = By.xpath("//*[@id='popup']//*[@placeholder='Procurar']");

    //FILTRO INICIAL:
    By clearFilter = By.xpath("//*[@data-zh-id='176086331530059978752776_filter_action_clear']");
    By IconeUnidade = By.xpath("//div[@id='NMFILIAL']//span[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By SelecioanarUnidadeAjusteIventario = By.xpath("//*[@data-zh-field-name='NMFILIAL']//*[.='HELA INGREDIENTES BRASIL']");
    By btnIconAlmoxarifado1 = By.xpath("//div[@id='DSALMOXARIFE']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By almoxarifado = By.xpath("//span[text()='HELA MATRIZ']");
    By btnXlimparDataRetiradaEstFiltro = By.xpath(" //span[@zh-icon='no-border close-x'and @zh-stop-propagation-click='']");
    By IconeData = By.xpath("//div[@id='INTERVALO']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
    By DataEscolhidaInicial = By.xpath("//*[@id='zh-calendar-Calendar']//*[.='1']");
    By BtnOkFiltro = By.xpath("//*[@id='footer']/div[3]/ul/li/a/span");
    By aplicarFiltro = By.xpath("//span[text()='Aplicar filtro']"); //data-zh-id esta vazio

    //Retirada DE ESTOQUE:
    By btnAdicionar = By.xpath("//*[@id='footer']//*[@data-zh-id='176086331542828469142843']");
    By btnXlimparDatalancamento = By.xpath("//div[@class='zh-select-date zh-field-DTLANCESTQ']//*[@zh-icon='no-border close-x']");
    By IconeData2 = By.xpath("//*[@data-zh-id='176086331536328227812830']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
    By Datalancamento = By.xpath("//div[@class='day today']");

    By setor = By.xpath("//*[@id='NMSETOR']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By setorEscolhido = By.xpath("//span[text()='Administrativo']");

    By tipoRetirada = By.xpath("//*[@data-zh-id='176086331532745039722840']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By itemRetirada = By.xpath("//span[text()='CONSUMO DE PRODUÇÃO']");


    By descricao = By.xpath("//*[@zh-id='176086331540471671592831']");
    By btnAdicionar2 = By.xpath("//span[text()='Adicionar Produtos']");
    By btnAdicionar3 = By. xpath("//*[@id='footer']//*[@data-zh-id='17608633154900707662793']");
    By btnIconProduto = By.xpath("//*[@id='NMPRODUTO']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By produto = By.xpath("//span[text()='SUMO DE LIMAO - CX12 500ML']");

    //Informações Complementares do Produto
    By btnIconLimparAlmoxarifado = By.xpath("//*[@data-zh-id='764527517256954914288']//*[@class='zh-icon zh-icon-close-x zh-icon-no-border']");
    By btnIconProcurarAlmoxarifado = By.xpath("//*[@data-zh-id='764527517256954914288']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");


    By selectLote = By.xpath("//*[@data-zh-id='7645275172186633453300']//*[@tabindex='0']");
    By loteExistente = By.xpath("//ul[@class='list zh-new-select-list']/li[1]");

    By btnLupaLote = By. xpath("//*[@id='NRLOTEESTQ']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By lote = By.xpath("//span[text()='025/50']");

    By confirmar = By.xpath("//*[@data-zh-id='7645275174220205724322']//*[.='Confirmar']");

    //sub-aba Produtos:
    By campoQuantidade = By.xpath("//*[@zh-id='17608633159797388502786']");
    By campoValorDevolvido = By.xpath("//*[@zh-id='17608633159213244502788']");

    //salvar Item:

    By adicionarItem = By.xpath("//span[text()='Adicionar']");
    By btnSalvar = By.xpath("//span[text()='Salvar']");
    By btnVoltar = By.xpath("//span[text()='Voltar']");


    //Banco
    By numeroLancado = By.cssSelector("span[style*='padding-left: 0px;']:first-child");




    //Editar Retirada
    By btnSelecionarRetirada = By.xpath("//span[text()='Teste Automatizado Retirada de Estoque']");
    By btnEditar = By.xpath("//*[@data-zh-id='17608633158544395752845']");



    //Excluir
    By btnSelecionarItemExclir = By.xpath("//span[text()='Deletar']");
    By btnExcluir = By.xpath("//*[@data-zh-id='17608633154664921452847']");
    By btnSim = By.xpath("//span[text()='Sim']");



    public void preencherFiltroRetiradaDeEstoque(String descUnidade,String descAlmoxarifado){

        //FILTRO INICIAL:
        waitForVisibilityOfElementLocated(clearFilter);
        click(clearFilter);
        waitForInvisibilityOfElementLocated(loadingWait);
        //UNIDADE:
        waitForVisibilityOfElementLocated(IconeUnidade);
        click(IconeUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
        //inicio busca no float-control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
        //fim busca no float-control
        waitForVisibilityOfElementLocated(SelecioanarUnidadeAjusteIventario);
        click(SelecioanarUnidadeAjusteIventario);
        waitForInvisibilityOfElementLocated(loadingWait);

        //ALMOXARIFADO:
        waitForVisibilityOfElementLocated(btnIconAlmoxarifado1);
        click(btnIconAlmoxarifado1);
        waitForInvisibilityOfElementLocated(loadingWait);
        //inicio busca no float-control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(almoxarifado);
        click(almoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
        //fim  busca no float-control

        //DATA:
        waitForVisibilityOfElementLocated(btnXlimparDataRetiradaEstFiltro);
        click(btnXlimparDataRetiradaEstFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(IconeData);
        click(IconeData);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(DataEscolhidaInicial);
        click(DataEscolhidaInicial); //Data final aparece automaticamente.
        waitForVisibilityOfElementLocated(BtnOkFiltro);
        click(BtnOkFiltro); //data-zh-id esta vazio
        waitForInvisibilityOfElementLocated(loadingWait);
        //APLICAR FILTRO
        waitForVisibilityOfElementLocated(aplicarFiltro);
        click(aplicarFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void adicionarRetiradaDeEstoque(String cmpDesc, String descProduto, String quantidade,String descAlmoxarifado,String DescCampoLote,String valorDevolvido, String campoSetor, String campoRetirada){
        waitForVisibilityOfElementLocated(btnAdicionar);
        click(btnAdicionar);
        waitForInvisibilityOfElementLocated(loadingWait);




        //Sub-aba Retirada de Estoque:
        //Data Retirada:
        waitForVisibilityOfElementLocated(btnXlimparDatalancamento);
        click(btnXlimparDatalancamento);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(IconeData2);
        click(IconeData2);
        waitForInvisibilityOfElementLocated(loadingWait);


        waitForVisibilityOfElementLocated(Datalancamento);
        click(Datalancamento);
        waitForInvisibilityOfElementLocated(loadingWait);


        //setor
        waitForVisibilityOfElementLocated(setor);
        click(setor);
        waitForInvisibilityOfElementLocated(loadingWait);


        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,campoSetor);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(setorEscolhido);



        //Tipo de Retirada:
        waitForVisibilityOfElementLocated(tipoRetirada);
        click(tipoRetirada);
        waitForInvisibilityOfElementLocated(loadingWait);


        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,campoRetirada);
        click(itemRetirada);
        waitForInvisibilityOfElementLocated(loadingWait);


        //Descrição
        waitForVisibilityOfElementLocated(descricao);
        click(descricao);
        sendKeys(descricao, cmpDesc);
        waitForInvisibilityOfElementLocated(loadingWait);


        //Adicionar:
        waitForVisibilityOfElementLocated(btnAdicionar2);
        click(btnAdicionar2);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnAdicionar3);
        click(btnAdicionar3);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Produto
        waitForVisibilityOfElementLocated(btnIconProduto);
        click(btnIconProduto);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Inicio Busca no float-control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click( campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descProduto);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(produto);
        click(produto);
        waitForInvisibilityOfElementLocated(loadingWait);
        //Fim da busca no Float-Control


        //Campo Informações Complementares do Produto:
        waitForVisibilityOfElementLocated(btnIconLimparAlmoxarifado);
        click(btnIconLimparAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnIconProcurarAlmoxarifado);
        click(btnIconProcurarAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);

        //inicio busca no float-control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(almoxarifado);
        click(almoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
        //fim  busca no float-control

        //lote:
        waitForVisibilityOfElementLocated(selectLote);
        click(selectLote);
        waitForVisibilityOfElementLocated(loteExistente);
        click(loteExistente);
        //waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnLupaLote);
        click(btnLupaLote);

        //inicio float control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,DescCampoLote);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(lote);
        click(lote);
        waitForInvisibilityOfElementLocated(loadingWait);
        // Fim Float- control



        //btn confirmar:
        waitForVisibilityOfElementLocated(confirmar);
        click(confirmar);
        waitForInvisibilityOfElementLocated(loadingWait);

        //sub-aba Produtos:
        //Quantidade:
        waitForVisibilityOfElementLocated(campoQuantidade);
        sendKeys(campoQuantidade,quantidade);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Quantidade devolvida:
        waitForVisibilityOfElementLocated(campoValorDevolvido);
        sendKeys(campoValorDevolvido,valorDevolvido);
       waitForInvisibilityOfElementLocated(loadingWait);

        //Salvar Item:
        waitForVisibilityOfElementLocated(adicionarItem);
       click(adicionarItem);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnSalvar);
       click(btnSalvar);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Banco captura
     //waitForVisibilityOfElementLocated(btnVoltar);
     // click(btnVoltar);
       //waitForInvisibilityOfElementLocated(loadingWait);
      waitForVisibilityOfElementLocated(numeroLancado);
       click(numeroLancado);
       waitForInvisibilityOfElementLocated(loadingWait);

    }
    //Banco tela de entrada
    public  String retornaNumeroLancamento(){return getText(numeroLancado);}
    public String retornaQuantidadeSolicitada(){return  getText(numeroLancado);}
    public String retornaQuantidadeDevolvida(){return getText(numeroLancado);}
    public String retornaQuantidadeRestante(){return  getText(numeroLancado);}



    public void editarRetiradaEstoque(String campoEditado){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnSelecionarRetirada);
        click(btnSelecionarRetirada);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(btnEditar);
        click(btnEditar);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(descricao);
        clearAndSendKeys(descricao,campoEditado);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(btnSalvar);
        click(btnSalvar);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(btnVoltar);
        click(btnVoltar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void excluirRetiradaEstoque(){
        waitForVisibilityOfElementLocated(btnSelecionarItemExclir);
        click(btnSelecionarItemExclir);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(btnExcluir);
        click(btnExcluir);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(btnSim);
        click(btnSim);
        waitForInvisibilityOfElementLocated(loadingWait);



    }
}