package com.javaseleniumtemplate.pages.Parametrizacao;
import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
public class ProdutoPage extends PageBase {

        //Evento de loading da pagina:
            By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");

        //BUSCA DO PRODUTO ATRAVES DO FLOAT-CONTROL:
            By iconFloatControl= By.xpath("//*[@class='zh-floating-control pos-bottom pos-right ui-draggable ui-draggable-handle']");
            By searchIcon = By.xpath("//*[@data-zh-id='zh-floating-control-custom-action-1']");
            By searchIcon2 = By.xpath("//*[@data-zh-id='zh-floating-control-handle']");
            By campoProcurarFloatControlProduto = By.xpath("//*[@class='floating-card-input']//*[@placeholder='Procurar']");
            By campoProcurarFloatControl = By.xpath("//*[@id='popup']//*[@placeholder='Procurar']");



        //ADICIONAR PRODUTO:
            By btnAdicionar = By.xpath("//*[@id='footer']//*[@data-zh-id='140777633833905578291108']");

        //DADOS DO PRODUTO_ESTOQUE:
            By CodigoArvoreSearch = By.xpath("//*[@data-zh-id='1407776338689942355877']//*[@zh-icon='no-border search']");
            By produtoEstoque = By.xpath("//*[@id='grid-9009']//*[.='PRODUTO TESTE AUTOMATIZADOS']");//Nao precisa de data-zh-id
            By nome = By.xpath("//*[@zh-id='14077763383745162835884']");//Nao precisa de data-zh-id
            By UnidadeMedidaSearch = By.xpath("//*[@id='SGUNIDADE']//*[@zh-icon='no-border search']");
            By unidade = By.xpath("//*[@data-zh-field-name='DSUNIDADE']//*[.='Litro']");//Nao precisa de data-zh-id
            By tipoProduto = By.xpath("//*[@data-zh-id='1407776338347870136891']//*[@tabindex='0']");
            By estoqueValue = By.xpath("//*[@data-zh-id='1407776338347870136891']//*[@data-value='1']");
            By salvar = By.xpath("//*[@data-zh-id='14077763381057040872896']//*[.='Salvar']");

        //CONTAINER_ALERT:
            By containerAlert = By.xpath("//*[@class='zh-container-alert']");
            By okContainerAlert = By.xpath("//*[@data-zh-id='zh-footer-alert-button-0']");

        //ESTOQUE:
            By fatorCorrecao = By.xpath("//*[@zh-id='1407776338872539835905']");

            By btnSalvarEstoque = By.xpath("//*[@data-zh-id='14077763382889263416925']//*[.='Salvar']");


       //Excluir Produto:
            By nomeCadastroProdutoTipoEstoque = By.xpath("//*[@id='grid-14077763383814570156874']//*[.='Produto_Teste_Automatizado_Tipo_Estoque']");//Nao precisa de data-zh-id

            By btnExcluir = By.xpath("//*[@data-zh-id='1407776338642110683189']");
            By textoNenhumRegistroEncontrado = By.xpath("//*[@id='grid-14077763383814570156874']//*[.='Nenhum registro foi encontrado']");



    //Editar Produto:
            By btnEditar = By.xpath("//*[@data-zh-id='1407776338556374667894']");
            By codigoDeBarras = By.xpath("//*[@zh-id='14077763384163640479882']");
            By nomeCodificado = By.xpath("//*[@zh-id='14077763383986269413885']");
            By complementoDeNome = By.xpath("//*[@zh-id='14077763381847114992889']");
            By tamanho = By.xpath("//*[@zh-id='14077763383827371873400']");
            By informacoesAdicionaisDoProduto = By.xpath("//*[@zh-id='14077763383861560843890']");

    //Arvore de Produto
            By AdicionarProdutoArvoreEstoque = By.xpath("//*[@data-zh-id='125000397713589445781159']");
            By ProdutoNome = By.id("NMPRODUTO");
            By SalvarProduto = By.xpath("//span[text()='Salvar']");

            By GrupoOperadores = By.linkText("Grupo de Operadores");
            By AdicionarGrupoDeOperadores = By.xpath("//*[@data-zh-id='12500039771566821133747']");
            By BtnGrupoOperador = By.xpath("//div[@id='DSGRUPOPER']//*[@zh-icon='no-border search']");
            By Operador = By.xpath("//span[text()='ADMINISTRATIVO']");

            By CadastroProdutoEstoque = By.xpath("//div[@data-zh-id='12500039772051487735745']");
            By SelecionarOpcao = By.xpath("//ul[@class='list zh-new-select-list']/li[1]");






    public void AdicionarProdutoEstoque(String codigoProduto, String nomeProduto, String unidadeMedida, String valorFatorCorrecao){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnAdicionar);
        click(btnAdicionar);
        waitForInvisibilityOfElementLocated(loadingWait);


        //DADOS DO PRODUTO:

        waitForVisibilityOfElementLocated(CodigoArvoreSearch);
        click(CodigoArvoreSearch);
        waitForInvisibilityOfElementLocated(loadingWait);
            //inicio busca no float-control
            waitForVisibilityOfElementLocated(campoProcurarFloatControl);
            click(campoProcurarFloatControl);
            sendKeys(campoProcurarFloatControl,codigoProduto);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(produtoEstoque);
            click(produtoEstoque);
            waitForInvisibilityOfElementLocated(loadingWait);


            //fim  busca no float-control
        waitForVisibilityOfElementLocated(nome);
        sendKeys(nome,nomeProduto);

        waitForVisibilityOfElementLocated(UnidadeMedidaSearch);
        click(UnidadeMedidaSearch);
        waitForInvisibilityOfElementLocated(loadingWait);
            //inicio busca no float-control
            waitForVisibilityOfElementLocated(campoProcurarFloatControl);
          sendKeys(campoProcurarFloatControl,unidadeMedida);
           waitForInvisibilityOfElementLocated(loadingWait);
          waitForVisibilityOfElementLocated(unidade);
          click(unidade);
          waitForInvisibilityOfElementLocated(loadingWait);
            //fim  busca no float-control

        //TIPO DE PRODUTO:


        waitForVisibilityOfElementLocated(tipoProduto);
       click(tipoProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(estoqueValue);
        click(estoqueValue);


        //SALVAR:
        waitForVisibilityOfElementLocated(salvar);
       click(salvar);
       waitForInvisibilityOfElementLocated(loadingWait);

        //CONTAINER_ALERT:
       //waitForVisibilityOfElementLocated(containerAlert);
      // waitForVisibilityOfElementLocated(okContainerAlert);
      // click(okContainerAlert);
      // waitForInvisibilityOfElementLocated(loadingWait);

        //FATOR DE CORREÇÂO:
        waitForVisibilityOfElementLocated(fatorCorrecao);
        sendKeys(fatorCorrecao,valorFatorCorrecao);
        waitForInvisibilityOfElementLocated(loadingWait);

        //SALVAR:
       waitForVisibilityOfElementLocated(btnSalvarEstoque);
        click(btnSalvarEstoque);

    }



    public void EditarProdutoEstoque(String nomeProduto, String numeroDoCodigoDeBarras, String descricaoComplementoDeNome, String DescricaoNomeCodificado, String descricaoTamanho,String descricaoinformacoesAdicionaisDoProduto) {

        //PROCURANDO PRODUTO
        waitForVisibilityOfElementLocated(iconFloatControl);
        click(iconFloatControl);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(searchIcon);
        click(searchIcon);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(campoProcurarFloatControlProduto);
        sendKeys(campoProcurarFloatControlProduto,nomeProduto);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(nomeCadastroProdutoTipoEstoque);
        click(nomeCadastroProdutoTipoEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);

        //EDITANDO PRODUTO
        waitForVisibilityOfElementLocated(btnEditar);
        click(btnEditar);
        waitForInvisibilityOfElementLocated(loadingWait);

        //DADOS DO PRODUTO
        waitForVisibilityOfElementLocated(codigoDeBarras);
        sendKeys(codigoDeBarras,numeroDoCodigoDeBarras);
        waitForVisibilityOfElementLocated(codigoDeBarras);
        sendKeys(nomeCodificado,DescricaoNomeCodificado);
        waitForVisibilityOfElementLocated(complementoDeNome);
        sendKeys(complementoDeNome,descricaoComplementoDeNome);
        waitForVisibilityOfElementLocated(tamanho);
        sendKeys(tamanho,descricaoTamanho);
        waitForVisibilityOfElementLocated(informacoesAdicionaisDoProduto);
        sendKeys(informacoesAdicionaisDoProduto,descricaoinformacoesAdicionaisDoProduto);

        //SALVAR:
        waitForVisibilityOfElementLocated(salvar);
        click(salvar);
        waitForInvisibilityOfElementLocated(loadingWait);


    }

    public void ExcluirProdutoEstoque(String nomeProduto){

       //PROCURANDO PRODUTO
            waitForVisibilityOfElementLocated(iconFloatControl);
            click(iconFloatControl);
            waitForInvisibilityOfElementLocated(loadingWait);

            waitForVisibilityOfElementLocated(searchIcon);
            click(searchIcon);
            waitForInvisibilityOfElementLocated(loadingWait);

            waitForVisibilityOfElementLocated(campoProcurarFloatControlProduto);
            sendKeys(campoProcurarFloatControlProduto,nomeProduto);
            waitForInvisibilityOfElementLocated(loadingWait);

            waitForVisibilityOfElementLocated(nomeCadastroProdutoTipoEstoque);
            click(nomeCadastroProdutoTipoEstoque);
            waitForInvisibilityOfElementLocated(loadingWait);

        //EXCLUINDO PRODUTO
            waitForVisibilityOfElementLocated(btnExcluir);
            click(btnExcluir);
            waitForInvisibilityOfElementLocated(loadingWait);

        //CONFERINDO EXCLUSAO PRODUTO

            waitForVisibilityOfElementLocated(searchIcon2);
            click(searchIcon2);
            waitForInvisibilityOfElementLocated(loadingWait);

            waitForVisibilityOfElementLocated(searchIcon);
            click(searchIcon);
            waitForInvisibilityOfElementLocated(loadingWait);

            waitForVisibilityOfElementLocated(campoProcurarFloatControlProduto);
            clear(campoProcurarFloatControlProduto);
            waitForInvisibilityOfElementLocated(loadingWait);
            sendKeys(campoProcurarFloatControlProduto,nomeProduto);
            waitForInvisibilityOfElementLocated(loadingWait);

            waitForVisibilityOfElementLocated(textoNenhumRegistroEncontrado);


    }

    // Arvore de Produto
    public void ArvoreDeProduto(String campoProdutoNome, String campoOperador){
    waitForInvisibilityOfElementLocated(loadingWait);
    waitForVisibilityOfElementLocated(AdicionarProdutoArvoreEstoque);
    click(AdicionarProdutoArvoreEstoque);
    waitForInvisibilityOfElementLocated(loadingWait);

    //Nome
     waitForVisibilityOfElementLocated(ProdutoNome);
     sendKeys(ProdutoNome,campoProdutoNome);
     waitForInvisibilityOfElementLocated(loadingWait);

     //Grupo de Operadores
        waitForVisibilityOfElementLocated(GrupoOperadores);
        click(GrupoOperadores);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(AdicionarGrupoDeOperadores);
        click(AdicionarGrupoDeOperadores);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(BtnGrupoOperador);
        click(BtnGrupoOperador);
        waitForInvisibilityOfElementLocated(loadingWait);

        //start Float-Control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,campoOperador);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(Operador);
        click(Operador);
        waitForInvisibilityOfElementLocated(loadingWait);
        //End search Float Control


     //Cadastro Produto Estoque

        waitForVisibilityOfElementLocated(CadastroProdutoEstoque);
        click(CadastroProdutoEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(SelecionarOpcao);
        click(SelecionarOpcao);
        waitForInvisibilityOfElementLocated(loadingWait);


     //Salvar
     // waitForVisibilityOfElementLocated(SalvarProduto);
      //click(SalvarProduto);
      //waitForInvisibilityOfElementLocated(loadingWait);


    }


}
